Index: tools/list2cds
===================================================================
--- tools/list2cds	(revision 86)
+++ tools/list2cds	(revision 89)
@@ -20,7 +20,7 @@
 my $forcenonusoncd1 = $ENV{'FORCENONUSONCD1'} || 0;
 my $local = $ENV{'LOCAL'} || 0;
 my $complete = $ENV{'COMPLETE'} || 0;
-my $exclude = $ENV{'EXCLUDE'} || "$list.exclude";
+my $exclude = "$list.exclude";
 my $norecommends = $ENV{'NORECOMMENDS'} || 0;
 my $nosuggests = $ENV{'NOSUGGESTS'} || 1;
 
Index: debian/changelog
===================================================================
Index: Makefile
===================================================================
--- Makefile	(revision 86)
+++ Makefile	(revision 89)
@@ -273,7 +273,9 @@
 # Deleting the list only
 deletelist: ok
 	$(Q)-rm $(BDIR)/rawlist
+	$(Q)-rm $(BDIR)/rawlist-exclude
 	$(Q)-rm $(BDIR)/list
+	$(Q)-rm $(BDIR)/list.exclude
 
 # Generates the list of packages/files to put on each CD
 list: bin-list src-list
@@ -321,7 +323,7 @@
 
 # Generate the complete listing of packages from the task
 # Build a nice list without doubles and without spaces
-genlist: ok $(BDIR)/list
+genlist: ok $(BDIR)/list $(BDIR)/list.exclude
 $(BDIR)/list: $(BDIR)/rawlist
 	@echo "Generating the complete list of packages to be included ..."
 	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
@@ -329,6 +331,14 @@
 		  $(BDIR)/rawlist \
 		  > $(BDIR)/list
 
+
+$(BDIR)/list.exclude: $(BDIR)/rawlist-exclude
+	@echo "Generating the complete list of packages to be removed ..."
+	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
+	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
+		  $(BDIR)/rawlist-exclude \
+		  > $(BDIR)/list.exclude
+
 # Build the raw list (cpp output) with doubles and spaces
 $(BDIR)/rawlist:
 # Dirty workaround for saving space on netinst images, we add some hints.
@@ -351,6 +361,16 @@
 	     -DFORCENONUSONCD1=$(forcenonusoncd1) \
 	     -I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist
 
+# Build the raw list (cpp output) with doubles and spaces for excluded packages
+$(BDIR)/rawlist-exclude:
+	$(Q)if [ -n $(EXCLUDE) ]; then \
+	 	perl -npe 's/\@ARCH\@/$(ARCH)/g' $(EXCLUDE) | \
+			cpp -nostdinc -nostdinc++ -P -undef -D ARCH=$(ARCH) -D ARCH_$(ARCH) \
+				-U $(ARCH) -U i386 -U linux -U unix \
+	     			-DFORCENONUSONCD1=$(forcenonusoncd1) \
+	     			-I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist-exclude; \
+	fi
+
 ## DIRECTORIES && PACKAGES && INFOS ##
 
 # Create all the needed directories for installing packages (plus the
